/**
 * generated by Xtext 2.15.0
 */
package org.xtext.ungs.drake.generator;

import com.google.common.collect.Iterables;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.xtext.ungs.drake.drake.Factor;
import org.xtext.ungs.drake.drake.Formulation;
import org.xtext.ungs.drake.drake.LinearExpression;
import org.xtext.ungs.drake.drake.LinearInequation;
import org.xtext.ungs.drake.drake.Model;
import org.xtext.ungs.drake.drake.Variable;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class DrakeGenerator extends AbstractGenerator {
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    Iterable<Model> _filter = Iterables.<Model>filter(IteratorExtensions.<EObject>toIterable(resource.getAllContents()), Model.class);
    for (final Model e : _filter) {
      fsa.generateFile(
        (("models/" + "archivo-generado") + ".java"), 
        this.compile(e));
    }
  }
  
  public CharSequence compile(final Model model) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<Formulation> _formulation = model.getFormulation();
      for(final Formulation f : _formulation) {
        CharSequence _compile = this.compile(f);
        _builder.append(_compile);
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  public CharSequence compile(final Formulation formulation) {
    StringConcatenation _builder = new StringConcatenation();
    String _function = formulation.getFunction();
    _builder.append(_function);
    _builder.append(" ");
    CharSequence _compile = this.compile(formulation.getExpression());
    _builder.append(_compile);
    _builder.append(" st ");
    {
      EList<LinearInequation> _inequation = formulation.getInequation();
      boolean _hasElements = false;
      for(final LinearInequation ine : _inequation) {
        if (!_hasElements) {
          _hasElements = true;
        } else {
          _builder.appendImmediate(", ", "");
        }
        CharSequence _compile_1 = this.compile(ine);
        _builder.append(_compile_1);
      }
    }
    return _builder;
  }
  
  public CharSequence compile(final LinearInequation linearInequation) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _compile = this.compile(linearInequation.getLinearExpression());
    _builder.append(_compile);
    _builder.append(" ");
    String _simbol = linearInequation.getSimbol();
    _builder.append(_simbol);
    _builder.append(" ");
    {
      Variable _varInequality = linearInequation.getVarInequality();
      boolean _tripleNotEquals = (_varInequality != null);
      if (_tripleNotEquals) {
        _builder.newLineIfNotEmpty();
        CharSequence _compile_1 = this.compile(linearInequation.getVarInequality());
        _builder.append(_compile_1);
      } else {
        int _intInequality = linearInequation.getIntInequality();
        _builder.append(_intInequality);
      }
    }
    return _builder;
  }
  
  public CharSequence compile(final LinearExpression linearExpression) {
    StringConcatenation _builder = new StringConcatenation();
    {
      String _simbol = linearExpression.getSimbol();
      boolean _tripleNotEquals = (_simbol != null);
      if (_tripleNotEquals) {
        CharSequence _compile = this.compile(linearExpression.getFactor());
        _builder.append(_compile);
        _builder.append(" ");
        String _simbol_1 = linearExpression.getSimbol();
        _builder.append(_simbol_1);
        _builder.append(" ");
        CharSequence _compile_1 = this.compile(linearExpression.getExpression());
        _builder.append(_compile_1);
      } else {
        Factor _factor = linearExpression.getFactor();
        boolean _tripleNotEquals_1 = (_factor != null);
        if (_tripleNotEquals_1) {
          _builder.newLineIfNotEmpty();
          CharSequence _compile_2 = this.compile(linearExpression.getFactor());
          _builder.append(_compile_2);
        } else {
          _builder.newLineIfNotEmpty();
          int _value = linearExpression.getValue();
          _builder.append(_value);
        }
      }
    }
    return _builder;
  }
  
  public CharSequence compile(final Factor factor) {
    StringConcatenation _builder = new StringConcatenation();
    {
      String _simbolo = factor.getSimbolo();
      boolean _tripleNotEquals = (_simbolo != null);
      if (_tripleNotEquals) {
        int _value = factor.getValue();
        _builder.append(_value);
        _builder.append(" ");
        String _simbolo_1 = factor.getSimbolo();
        _builder.append(_simbolo_1);
        _builder.append(" ");
      }
    }
    CharSequence _compile = this.compile(factor.getVariable());
    _builder.append(_compile);
    return _builder;
  }
  
  public CharSequence compile(final Variable variable) {
    StringConcatenation _builder = new StringConcatenation();
    String _name = variable.getName();
    _builder.append(_name);
    {
      int _size = variable.getIndex().size();
      boolean _notEquals = (_size != 0);
      if (_notEquals) {
        _builder.append("_{");
        {
          EList<Integer> _index = variable.getIndex();
          boolean _hasElements = false;
          for(final Integer ind : _index) {
            if (!_hasElements) {
              _hasElements = true;
            } else {
              _builder.appendImmediate(",", "");
            }
            _builder.append(ind);
          }
        }
        _builder.append("}");
      }
    }
    return _builder;
  }
}
